/**
 * 新充电流程：验证插头模块
 * @邠心vbe on 2023/06/20
 */
import React, { useEffect, useState } from 'react';
import { View, Text, Image, StyleSheet } from 'react-native';
import app from '../../../app.json';
import Button from '../../components/Button';
import TextView from '../../components/TextView';
import { PaymentList } from '../chargeV2/Payment';
import PaymentListV2 from '../chargeV2/PaymentListV2';

export default StepAuth = ({
  status="",
  currentPayment,
  onStartCharge,
  chargeBoxId,
  onPaymentMethodChanged
}) => {
  const [loadingEmps, setEmps] = useState("");
  const [isAuthentic, setAuthentic] = useState(false)
  useEffect(() => {
    if (status == "Preparing") {
      setAuthentic(true);
    } else {
      changeEmps();
    }
  }, []);

  useEffect(() => {
    if (status == "Preparing") {
      setAuthentic(true);
    } else {
      setTimeout(() => {
        changeEmps();
      }, 500);
    }
  }, [loadingEmps, status]);

  const changeEmps = () => {
    let emp = loadingEmps;
    if (loadingEmps.length == 3) {
      emp = "";
    } else {
      emp += ".";
    }
    setEmps(emp);
  }

  return (
    <View style={styles.container}>
      <View style={styles.content}>
        <Image
          style={styles.stepImage}
          resizeMode="contain"
          source={
            isAuthentic
            ? require('../../images/site/charging-status-auth.png')
            : require('../../images/site/charging-status-ready.png')
          }/>
        { isAuthentic
        ? <TextView style={styles.stepTitle}>{$t('charging.stepAuthenticated')}</TextView>
        : <View style={ui.flexcc}>
            <TextView style={styles.stepTitle}>{$t('charging.stepAuthenticating')}</TextView>
            <TextView style={[styles.stepTitle, {width: 30, marginRight: -10}]}>{loadingEmps}</TextView>
          </View>
        }
        <TextView style={styles.stepDesc}>{$t(isAuthentic ? 'charging.stepAuthenticatedDesc' : 'charging.stepAuthenticatingDesc')}</TextView>
      </View>
      <View style={styles.bottomView}>
        <TextView style={styles.label}>{$t('charging.paymentMethod')}</TextView>
        {/* <PaymentList
          payType={currentPayment}
          onMethodChange={onPaymentMethodChanged}
        /> */}
        { app.v3.paymentMethod
        ? <PaymentListV2
            isSelect={isAuthentic}
            payType={currentPayment}
            chargeBoxId={chargeBoxId}
            onMethodChange={onPaymentMethodChanged}/>
        : <PaymentList
            isSelect={isAuthentic}
            payType={currentPayment}
            onMethodChange={onPaymentMethodChanged}/>
        }
        { isAuthentic
        ? <Button
            style={styles.buttonView}
            text={$t('charging.btnStartCharging')}
            elevation={1.5}
            borderRadius={6}
            onClick={onStartCharge}/>
        : <View style={{height: 56}}/>
        }
      </View>
    </View>
  );
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    padding: 16
  },
  content: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center'
  },
  stepImage: {
    width: $vw(70),
    height: $vw(16),
    margin: 16
  },
  stepTitle: {
    fontSize: 24,
    fontWeight: 'bold',
    color: colorAccent
  },
  stepDesc: {
    color: textPrimary,
    fontSize: 16,
    textAlign: 'center',
    ...$padding(0, 32, 48)
  },
  label: {
    color: '#000',
    fontSize: 14,
    fontWeight: 'bold',
    paddingTop: 16,
    paddingBottom: 8
  },
  bottomView: {
    paddingBottom: 16
  },
  buttonView: {
    marginTop: 8
  }
})